/* Automatically generated nanopb header */
/* Generated by nanopb-0.4.5 */

#ifndef PB_PARTICLE_CLOUD_LEDGER_CLOUD_LEDGER_PB_H_INCLUDED
#define PB_PARTICLE_CLOUD_LEDGER_CLOUD_LEDGER_PB_H_INCLUDED
#include <pb.h>

#if PB_PROTO_HEADER_VERSION != 40
#error Regenerate this file with the current version of nanopb generator.
#endif

/* Enum definitions */
/* *
 Scope type. */
typedef enum _particle_cloud_ledger_ScopeType { 
    particle_cloud_ledger_ScopeType_SCOPE_TYPE_UNKNOWN = 0, /* /< Unknown scope. */
    particle_cloud_ledger_ScopeType_SCOPE_TYPE_DEVICE = 1, /* /< Device scope. */
    particle_cloud_ledger_ScopeType_SCOPE_TYPE_PRODUCT = 2, /* /< Product scope. */
    particle_cloud_ledger_ScopeType_SCOPE_TYPE_OWNER = 3 /* /< Owner scope. */
} particle_cloud_ledger_ScopeType;

/* *
 Sync direction. */
typedef enum _particle_cloud_ledger_SyncDirection { 
    particle_cloud_ledger_SyncDirection_SYNC_DIRECTION_UNKNOWN = 0, /* /< Unknown direction. */
    particle_cloud_ledger_SyncDirection_SYNC_DIRECTION_DEVICE_TO_CLOUD = 1, /* /< Device to cloud. */
    particle_cloud_ledger_SyncDirection_SYNC_DIRECTION_CLOUD_TO_DEVICE = 2 /* /< Cloud to device. */
} particle_cloud_ledger_SyncDirection;

/* Struct definitions */
/* *
 Get the ledger info.

 This request is sent by the device. */
typedef struct _particle_cloud_ledger_GetInfoRequest { 
    /* *
 Names of the ledgers for which to request the info. */
    pb_callback_t ledgers; 
} particle_cloud_ledger_GetInfoRequest;

/* *
 Response for `GetInfoRequest`. */
typedef struct _particle_cloud_ledger_GetInfoResponse { 
    /* *
 Ledger info.

 A ledger is omitted in the response if it cannot be found or is not accessible by the device. */
    pb_callback_t ledgers; 
} particle_cloud_ledger_GetInfoResponse;

/* *
 Response for `ResetInfoRequest`. */
typedef struct _particle_cloud_ledger_NotifyUpdateRequest { 
    pb_callback_t ledgers; 
} particle_cloud_ledger_NotifyUpdateRequest;

typedef struct _particle_cloud_ledger_NotifyUpdateResponse { 
    char dummy_field;
} particle_cloud_ledger_NotifyUpdateResponse;

typedef struct _particle_cloud_ledger_ResetInfoRequest { 
    char dummy_field;
} particle_cloud_ledger_ResetInfoRequest;

typedef struct _particle_cloud_ledger_ResetInfoResponse { 
    char dummy_field;
} particle_cloud_ledger_ResetInfoResponse;

/* *
 Get the contents of a remote cloud-to-device ledger.

 This request is sent by the device. */
typedef struct _particle_cloud_ledger_SetDataResponse { 
    char dummy_field;
} particle_cloud_ledger_SetDataResponse;

/* *
 Response for `SubscribeRequest`. */
typedef struct _particle_cloud_ledger_SubscribeRequest { 
    pb_callback_t ledgers; /* /< Ledger info. */
} particle_cloud_ledger_SubscribeRequest;

/* *
 Response for `NotifyUpdateRequest`. */
typedef struct _particle_cloud_ledger_SubscribeResponse { 
    pb_callback_t ledgers; 
} particle_cloud_ledger_SubscribeResponse;

typedef PB_BYTES_ARRAY_T(32) particle_cloud_ledger_GetDataRequest_scope_id_t;
/* *
 Response for `GetDataRequest`. */
typedef struct _particle_cloud_ledger_GetDataRequest { 
    /* *
 Time the ledger was last updated, in milliseconds since the Unix epoch.

 If not set, the ledger has not yet been assigned any data. */
    char name[33]; /* *
 Contents of the ledger.

 If not set, the device has the most recent version of the ledger data. */
    /* XXX: Device OS currently requires this field to have the highest field number in the message. */
    particle_cloud_ledger_GetDataRequest_scope_id_t scope_id; 
    bool has_last_updated;
    uint64_t last_updated; 
} particle_cloud_ledger_GetDataRequest;

/* *
 Subscribe to notifications about updates made to one or multiple cloud-to-device ledgers.

 Subscriptions listed in this request will replace all the subscriptions currently registered on
 the server.

 This request is sent by the device. */
typedef struct _particle_cloud_ledger_GetDataResponse { 
    bool has_last_updated;
    uint64_t last_updated; /* /< Ledgers to subscribe to. */
    pb_callback_t data; 
} particle_cloud_ledger_GetDataResponse;

typedef PB_BYTES_ARRAY_T(32) particle_cloud_ledger_GetInfoResponse_Ledger_scope_id_t;
/* *
 Update the contents of a remote device-to-cloud ledger.

 This request is sent by the device. */
typedef struct _particle_cloud_ledger_GetInfoResponse_Ledger { 
    char name[33]; /* /< Ledger name. */
    particle_cloud_ledger_GetInfoResponse_Ledger_scope_id_t scope_id; /* /< Scope ID. */
    /* *
 Time the ledger was last updated, in milliseconds since the Unix epoch.

 If not set, the time is unknown. */
    particle_cloud_ledger_ScopeType scope_type; /* *
 Contents of the ledger. */
    /* XXX: Device OS currently requires this field to have the highest field number in the message. */
    particle_cloud_ledger_SyncDirection sync_direction; 
    bool has_last_updated;
    uint64_t last_updated; 
} particle_cloud_ledger_GetInfoResponse_Ledger;

typedef struct _particle_cloud_ledger_NotifyUpdateRequest_Ledger { 
    char name[33]; 
    uint64_t last_updated; 
} particle_cloud_ledger_NotifyUpdateRequest_Ledger;

typedef PB_BYTES_ARRAY_T(32) particle_cloud_ledger_SetDataRequest_scope_id_t;
/* *
 Response for `SetDataRequest`. */
typedef struct _particle_cloud_ledger_SetDataRequest { 
    char name[33]; 
    particle_cloud_ledger_SetDataRequest_scope_id_t scope_id; 
    bool has_last_updated;
    uint64_t last_updated; 
    pb_callback_t data; 
} particle_cloud_ledger_SetDataRequest;

typedef PB_BYTES_ARRAY_T(32) particle_cloud_ledger_SubscribeRequest_Ledger_scope_id_t;
/* *
 Notify the device that one or more cloud-to-device ledgers were updated.

 This request is sent by the server. */
typedef struct _particle_cloud_ledger_SubscribeRequest_Ledger { 
    char name[33]; /* /< Ledger info. */
    particle_cloud_ledger_SubscribeRequest_Ledger_scope_id_t scope_id; 
} particle_cloud_ledger_SubscribeRequest_Ledger;

/* *
 Notify the device that it needs to re-request the info about all ledgers in use.

 This request is sent by the server. */
typedef struct _particle_cloud_ledger_SubscribeResponse_Ledger { 
    char name[33]; 
    bool has_last_updated;
    uint64_t last_updated; 
} particle_cloud_ledger_SubscribeResponse_Ledger;


/* Helper constants for enums */
#define _particle_cloud_ledger_ScopeType_MIN particle_cloud_ledger_ScopeType_SCOPE_TYPE_UNKNOWN
#define _particle_cloud_ledger_ScopeType_MAX particle_cloud_ledger_ScopeType_SCOPE_TYPE_OWNER
#define _particle_cloud_ledger_ScopeType_ARRAYSIZE ((particle_cloud_ledger_ScopeType)(particle_cloud_ledger_ScopeType_SCOPE_TYPE_OWNER+1))

#define _particle_cloud_ledger_SyncDirection_MIN particle_cloud_ledger_SyncDirection_SYNC_DIRECTION_UNKNOWN
#define _particle_cloud_ledger_SyncDirection_MAX particle_cloud_ledger_SyncDirection_SYNC_DIRECTION_CLOUD_TO_DEVICE
#define _particle_cloud_ledger_SyncDirection_ARRAYSIZE ((particle_cloud_ledger_SyncDirection)(particle_cloud_ledger_SyncDirection_SYNC_DIRECTION_CLOUD_TO_DEVICE+1))


#ifdef __cplusplus
extern "C" {
#endif

/* Initializer values for message structs */
#define particle_cloud_ledger_GetInfoRequest_init_default {{{NULL}, NULL}}
#define particle_cloud_ledger_GetInfoResponse_init_default {{{NULL}, NULL}}
#define particle_cloud_ledger_GetInfoResponse_Ledger_init_default {"", {0, {0}}, _particle_cloud_ledger_ScopeType_MIN, _particle_cloud_ledger_SyncDirection_MIN, false, 0}
#define particle_cloud_ledger_SetDataRequest_init_default {"", {0, {0}}, false, 0, {{NULL}, NULL}}
#define particle_cloud_ledger_SetDataResponse_init_default {0}
#define particle_cloud_ledger_GetDataRequest_init_default {"", {0, {0}}, false, 0}
#define particle_cloud_ledger_GetDataResponse_init_default {false, 0, {{NULL}, NULL}}
#define particle_cloud_ledger_SubscribeRequest_init_default {{{NULL}, NULL}}
#define particle_cloud_ledger_SubscribeRequest_Ledger_init_default {"", {0, {0}}}
#define particle_cloud_ledger_SubscribeResponse_init_default {{{NULL}, NULL}}
#define particle_cloud_ledger_SubscribeResponse_Ledger_init_default {"", false, 0}
#define particle_cloud_ledger_NotifyUpdateRequest_init_default {{{NULL}, NULL}}
#define particle_cloud_ledger_NotifyUpdateRequest_Ledger_init_default {"", 0}
#define particle_cloud_ledger_NotifyUpdateResponse_init_default {0}
#define particle_cloud_ledger_ResetInfoRequest_init_default {0}
#define particle_cloud_ledger_ResetInfoResponse_init_default {0}
#define particle_cloud_ledger_GetInfoRequest_init_zero {{{NULL}, NULL}}
#define particle_cloud_ledger_GetInfoResponse_init_zero {{{NULL}, NULL}}
#define particle_cloud_ledger_GetInfoResponse_Ledger_init_zero {"", {0, {0}}, _particle_cloud_ledger_ScopeType_MIN, _particle_cloud_ledger_SyncDirection_MIN, false, 0}
#define particle_cloud_ledger_SetDataRequest_init_zero {"", {0, {0}}, false, 0, {{NULL}, NULL}}
#define particle_cloud_ledger_SetDataResponse_init_zero {0}
#define particle_cloud_ledger_GetDataRequest_init_zero {"", {0, {0}}, false, 0}
#define particle_cloud_ledger_GetDataResponse_init_zero {false, 0, {{NULL}, NULL}}
#define particle_cloud_ledger_SubscribeRequest_init_zero {{{NULL}, NULL}}
#define particle_cloud_ledger_SubscribeRequest_Ledger_init_zero {"", {0, {0}}}
#define particle_cloud_ledger_SubscribeResponse_init_zero {{{NULL}, NULL}}
#define particle_cloud_ledger_SubscribeResponse_Ledger_init_zero {"", false, 0}
#define particle_cloud_ledger_NotifyUpdateRequest_init_zero {{{NULL}, NULL}}
#define particle_cloud_ledger_NotifyUpdateRequest_Ledger_init_zero {"", 0}
#define particle_cloud_ledger_NotifyUpdateResponse_init_zero {0}
#define particle_cloud_ledger_ResetInfoRequest_init_zero {0}
#define particle_cloud_ledger_ResetInfoResponse_init_zero {0}

/* Field tags (for use in manual encoding/decoding) */
#define particle_cloud_ledger_GetInfoRequest_ledgers_tag 1
#define particle_cloud_ledger_GetInfoResponse_ledgers_tag 1
#define particle_cloud_ledger_NotifyUpdateRequest_ledgers_tag 1
#define particle_cloud_ledger_SubscribeRequest_ledgers_tag 1
#define particle_cloud_ledger_SubscribeResponse_ledgers_tag 1
#define particle_cloud_ledger_GetDataRequest_name_tag 1
#define particle_cloud_ledger_GetDataRequest_scope_id_tag 2
#define particle_cloud_ledger_GetDataRequest_last_updated_tag 3
#define particle_cloud_ledger_GetDataResponse_last_updated_tag 1
#define particle_cloud_ledger_GetDataResponse_data_tag 10
#define particle_cloud_ledger_GetInfoResponse_Ledger_name_tag 1
#define particle_cloud_ledger_GetInfoResponse_Ledger_scope_id_tag 2
#define particle_cloud_ledger_GetInfoResponse_Ledger_scope_type_tag 3
#define particle_cloud_ledger_GetInfoResponse_Ledger_sync_direction_tag 4
#define particle_cloud_ledger_GetInfoResponse_Ledger_last_updated_tag 5
#define particle_cloud_ledger_NotifyUpdateRequest_Ledger_name_tag 1
#define particle_cloud_ledger_NotifyUpdateRequest_Ledger_last_updated_tag 2
#define particle_cloud_ledger_SetDataRequest_name_tag 1
#define particle_cloud_ledger_SetDataRequest_scope_id_tag 2
#define particle_cloud_ledger_SetDataRequest_last_updated_tag 3
#define particle_cloud_ledger_SetDataRequest_data_tag 10
#define particle_cloud_ledger_SubscribeRequest_Ledger_name_tag 1
#define particle_cloud_ledger_SubscribeRequest_Ledger_scope_id_tag 2
#define particle_cloud_ledger_SubscribeResponse_Ledger_name_tag 1
#define particle_cloud_ledger_SubscribeResponse_Ledger_last_updated_tag 2

/* Struct field encoding specification for nanopb */
#define particle_cloud_ledger_GetInfoRequest_FIELDLIST(X, a) \
X(a, CALLBACK, REPEATED, STRING,   ledgers,           1)
#define particle_cloud_ledger_GetInfoRequest_CALLBACK pb_default_field_callback
#define particle_cloud_ledger_GetInfoRequest_DEFAULT NULL

#define particle_cloud_ledger_GetInfoResponse_FIELDLIST(X, a) \
X(a, CALLBACK, REPEATED, MESSAGE,  ledgers,           1)
#define particle_cloud_ledger_GetInfoResponse_CALLBACK pb_default_field_callback
#define particle_cloud_ledger_GetInfoResponse_DEFAULT NULL
#define particle_cloud_ledger_GetInfoResponse_ledgers_MSGTYPE particle_cloud_ledger_GetInfoResponse_Ledger

#define particle_cloud_ledger_GetInfoResponse_Ledger_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, STRING,   name,              1) \
X(a, STATIC,   SINGULAR, BYTES,    scope_id,          2) \
X(a, STATIC,   SINGULAR, UENUM,    scope_type,        3) \
X(a, STATIC,   SINGULAR, UENUM,    sync_direction,    4) \
X(a, STATIC,   OPTIONAL, FIXED64,  last_updated,      5)
#define particle_cloud_ledger_GetInfoResponse_Ledger_CALLBACK NULL
#define particle_cloud_ledger_GetInfoResponse_Ledger_DEFAULT NULL

#define particle_cloud_ledger_SetDataRequest_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, STRING,   name,              1) \
X(a, STATIC,   SINGULAR, BYTES,    scope_id,          2) \
X(a, STATIC,   OPTIONAL, FIXED64,  last_updated,      3) \
X(a, CALLBACK, SINGULAR, BYTES,    data,             10)
#define particle_cloud_ledger_SetDataRequest_CALLBACK pb_default_field_callback
#define particle_cloud_ledger_SetDataRequest_DEFAULT NULL

#define particle_cloud_ledger_SetDataResponse_FIELDLIST(X, a) \

#define particle_cloud_ledger_SetDataResponse_CALLBACK NULL
#define particle_cloud_ledger_SetDataResponse_DEFAULT NULL

#define particle_cloud_ledger_GetDataRequest_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, STRING,   name,              1) \
X(a, STATIC,   SINGULAR, BYTES,    scope_id,          2) \
X(a, STATIC,   OPTIONAL, FIXED64,  last_updated,      3)
#define particle_cloud_ledger_GetDataRequest_CALLBACK NULL
#define particle_cloud_ledger_GetDataRequest_DEFAULT NULL

#define particle_cloud_ledger_GetDataResponse_FIELDLIST(X, a) \
X(a, STATIC,   OPTIONAL, FIXED64,  last_updated,      1) \
X(a, CALLBACK, OPTIONAL, BYTES,    data,             10)
#define particle_cloud_ledger_GetDataResponse_CALLBACK pb_default_field_callback
#define particle_cloud_ledger_GetDataResponse_DEFAULT NULL

#define particle_cloud_ledger_SubscribeRequest_FIELDLIST(X, a) \
X(a, CALLBACK, REPEATED, MESSAGE,  ledgers,           1)
#define particle_cloud_ledger_SubscribeRequest_CALLBACK pb_default_field_callback
#define particle_cloud_ledger_SubscribeRequest_DEFAULT NULL
#define particle_cloud_ledger_SubscribeRequest_ledgers_MSGTYPE particle_cloud_ledger_SubscribeRequest_Ledger

#define particle_cloud_ledger_SubscribeRequest_Ledger_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, STRING,   name,              1) \
X(a, STATIC,   SINGULAR, BYTES,    scope_id,          2)
#define particle_cloud_ledger_SubscribeRequest_Ledger_CALLBACK NULL
#define particle_cloud_ledger_SubscribeRequest_Ledger_DEFAULT NULL

#define particle_cloud_ledger_SubscribeResponse_FIELDLIST(X, a) \
X(a, CALLBACK, REPEATED, MESSAGE,  ledgers,           1)
#define particle_cloud_ledger_SubscribeResponse_CALLBACK pb_default_field_callback
#define particle_cloud_ledger_SubscribeResponse_DEFAULT NULL
#define particle_cloud_ledger_SubscribeResponse_ledgers_MSGTYPE particle_cloud_ledger_SubscribeResponse_Ledger

#define particle_cloud_ledger_SubscribeResponse_Ledger_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, STRING,   name,              1) \
X(a, STATIC,   OPTIONAL, FIXED64,  last_updated,      2)
#define particle_cloud_ledger_SubscribeResponse_Ledger_CALLBACK NULL
#define particle_cloud_ledger_SubscribeResponse_Ledger_DEFAULT NULL

#define particle_cloud_ledger_NotifyUpdateRequest_FIELDLIST(X, a) \
X(a, CALLBACK, REPEATED, MESSAGE,  ledgers,           1)
#define particle_cloud_ledger_NotifyUpdateRequest_CALLBACK pb_default_field_callback
#define particle_cloud_ledger_NotifyUpdateRequest_DEFAULT NULL
#define particle_cloud_ledger_NotifyUpdateRequest_ledgers_MSGTYPE particle_cloud_ledger_NotifyUpdateRequest_Ledger

#define particle_cloud_ledger_NotifyUpdateRequest_Ledger_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, STRING,   name,              1) \
X(a, STATIC,   SINGULAR, FIXED64,  last_updated,      2)
#define particle_cloud_ledger_NotifyUpdateRequest_Ledger_CALLBACK NULL
#define particle_cloud_ledger_NotifyUpdateRequest_Ledger_DEFAULT NULL

#define particle_cloud_ledger_NotifyUpdateResponse_FIELDLIST(X, a) \

#define particle_cloud_ledger_NotifyUpdateResponse_CALLBACK NULL
#define particle_cloud_ledger_NotifyUpdateResponse_DEFAULT NULL

#define particle_cloud_ledger_ResetInfoRequest_FIELDLIST(X, a) \

#define particle_cloud_ledger_ResetInfoRequest_CALLBACK NULL
#define particle_cloud_ledger_ResetInfoRequest_DEFAULT NULL

#define particle_cloud_ledger_ResetInfoResponse_FIELDLIST(X, a) \

#define particle_cloud_ledger_ResetInfoResponse_CALLBACK NULL
#define particle_cloud_ledger_ResetInfoResponse_DEFAULT NULL

extern const pb_msgdesc_t particle_cloud_ledger_GetInfoRequest_msg;
extern const pb_msgdesc_t particle_cloud_ledger_GetInfoResponse_msg;
extern const pb_msgdesc_t particle_cloud_ledger_GetInfoResponse_Ledger_msg;
extern const pb_msgdesc_t particle_cloud_ledger_SetDataRequest_msg;
extern const pb_msgdesc_t particle_cloud_ledger_SetDataResponse_msg;
extern const pb_msgdesc_t particle_cloud_ledger_GetDataRequest_msg;
extern const pb_msgdesc_t particle_cloud_ledger_GetDataResponse_msg;
extern const pb_msgdesc_t particle_cloud_ledger_SubscribeRequest_msg;
extern const pb_msgdesc_t particle_cloud_ledger_SubscribeRequest_Ledger_msg;
extern const pb_msgdesc_t particle_cloud_ledger_SubscribeResponse_msg;
extern const pb_msgdesc_t particle_cloud_ledger_SubscribeResponse_Ledger_msg;
extern const pb_msgdesc_t particle_cloud_ledger_NotifyUpdateRequest_msg;
extern const pb_msgdesc_t particle_cloud_ledger_NotifyUpdateRequest_Ledger_msg;
extern const pb_msgdesc_t particle_cloud_ledger_NotifyUpdateResponse_msg;
extern const pb_msgdesc_t particle_cloud_ledger_ResetInfoRequest_msg;
extern const pb_msgdesc_t particle_cloud_ledger_ResetInfoResponse_msg;

/* Defines for backwards compatibility with code written before nanopb-0.4.0 */
#define particle_cloud_ledger_GetInfoRequest_fields &particle_cloud_ledger_GetInfoRequest_msg
#define particle_cloud_ledger_GetInfoResponse_fields &particle_cloud_ledger_GetInfoResponse_msg
#define particle_cloud_ledger_GetInfoResponse_Ledger_fields &particle_cloud_ledger_GetInfoResponse_Ledger_msg
#define particle_cloud_ledger_SetDataRequest_fields &particle_cloud_ledger_SetDataRequest_msg
#define particle_cloud_ledger_SetDataResponse_fields &particle_cloud_ledger_SetDataResponse_msg
#define particle_cloud_ledger_GetDataRequest_fields &particle_cloud_ledger_GetDataRequest_msg
#define particle_cloud_ledger_GetDataResponse_fields &particle_cloud_ledger_GetDataResponse_msg
#define particle_cloud_ledger_SubscribeRequest_fields &particle_cloud_ledger_SubscribeRequest_msg
#define particle_cloud_ledger_SubscribeRequest_Ledger_fields &particle_cloud_ledger_SubscribeRequest_Ledger_msg
#define particle_cloud_ledger_SubscribeResponse_fields &particle_cloud_ledger_SubscribeResponse_msg
#define particle_cloud_ledger_SubscribeResponse_Ledger_fields &particle_cloud_ledger_SubscribeResponse_Ledger_msg
#define particle_cloud_ledger_NotifyUpdateRequest_fields &particle_cloud_ledger_NotifyUpdateRequest_msg
#define particle_cloud_ledger_NotifyUpdateRequest_Ledger_fields &particle_cloud_ledger_NotifyUpdateRequest_Ledger_msg
#define particle_cloud_ledger_NotifyUpdateResponse_fields &particle_cloud_ledger_NotifyUpdateResponse_msg
#define particle_cloud_ledger_ResetInfoRequest_fields &particle_cloud_ledger_ResetInfoRequest_msg
#define particle_cloud_ledger_ResetInfoResponse_fields &particle_cloud_ledger_ResetInfoResponse_msg

/* Maximum encoded size of messages (where known) */
/* particle_cloud_ledger_GetInfoRequest_size depends on runtime parameters */
/* particle_cloud_ledger_GetInfoResponse_size depends on runtime parameters */
/* particle_cloud_ledger_SetDataRequest_size depends on runtime parameters */
/* particle_cloud_ledger_GetDataResponse_size depends on runtime parameters */
/* particle_cloud_ledger_SubscribeRequest_size depends on runtime parameters */
/* particle_cloud_ledger_SubscribeResponse_size depends on runtime parameters */
/* particle_cloud_ledger_NotifyUpdateRequest_size depends on runtime parameters */
#define particle_cloud_ledger_GetDataRequest_size 77
#define particle_cloud_ledger_GetInfoResponse_Ledger_size 81
#define particle_cloud_ledger_NotifyUpdateRequest_Ledger_size 43
#define particle_cloud_ledger_NotifyUpdateResponse_size 0
#define particle_cloud_ledger_ResetInfoRequest_size 0
#define particle_cloud_ledger_ResetInfoResponse_size 0
#define particle_cloud_ledger_SetDataResponse_size 0
#define particle_cloud_ledger_SubscribeRequest_Ledger_size 68
#define particle_cloud_ledger_SubscribeResponse_Ledger_size 43

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
