/* Automatically generated nanopb header */
/* Generated by nanopb-0.4.5 */

#ifndef PB_PARTICLE_CTRL_CONTROL_CONFIG_PB_H_INCLUDED
#define PB_PARTICLE_CTRL_CONTROL_CONFIG_PB_H_INCLUDED
#include <pb.h>
#include "control/extensions.pb.h"

#if PB_PROTO_HEADER_VERSION != 40
#error Regenerate this file with the current version of nanopb generator.
#endif

/* Enum definitions */
/* Note: Use the same values as defined by the security_key_type enum */
typedef enum _particle_ctrl_SecurityKeyType { 
    particle_ctrl_SecurityKeyType_INVALID_SECURITY_KEY = 0, /* Invalid key */
    particle_ctrl_SecurityKeyType_TCP_DEVICE_PRIVATE_KEY = 1, /* TCP device private key */
    particle_ctrl_SecurityKeyType_TCP_DEVICE_PUBLIC_KEY = 2, /* TCP device public key */
    particle_ctrl_SecurityKeyType_TCP_SERVER_PUBLIC_KEY = 3, /* TCP server public key */
    particle_ctrl_SecurityKeyType_UDP_DEVICE_PRIVATE_KEY = 4, /* UDP device private key */
    particle_ctrl_SecurityKeyType_UDP_DEVICE_PUBLIC_KEY = 5, /* UDP device public key */
    particle_ctrl_SecurityKeyType_UDP_SERVER_PUBLIC_KEY = 6 /* UDP server public key */
} particle_ctrl_SecurityKeyType;

/* Note: Use the same values as defined by the server_protocol_type enum */
typedef enum _particle_ctrl_ServerProtocolType { 
    particle_ctrl_ServerProtocolType_INVALID_PROTOCOL = 0, 
    particle_ctrl_ServerProtocolType_TCP_PROTOCOL = 1, /* TCP */
    particle_ctrl_ServerProtocolType_UDP_PROTOCOL = 2 /* UDP */
} particle_ctrl_ServerProtocolType;

/* Device mode */
typedef enum _particle_ctrl_DeviceMode { 
    particle_ctrl_DeviceMode_NORMAL_MODE = 0, /* Normal mode */
    particle_ctrl_DeviceMode_LISTENING_MODE = 1 /* Listening mode */
} particle_ctrl_DeviceMode;

/* System capability flags */
typedef enum _particle_ctrl_SystemCapabilityFlag { 
    particle_ctrl_SystemCapabilityFlag_NO_SYSTEM_CAPABILITY_FLAGS = 0, 
    particle_ctrl_SystemCapabilityFlag_COMPRESSED_OTA = 1 
} particle_ctrl_SystemCapabilityFlag;

/* System features */
typedef enum _particle_ctrl_Feature { 
    particle_ctrl_Feature_INVALID_FEATURE = 0, /* Invalid feature */
    particle_ctrl_Feature_ETHERNET_DETECTION = 1 /* Ethernet FeatherWing detection on boot */
} particle_ctrl_Feature;

/* Struct definitions */
/* Get the device ID */
typedef struct _particle_ctrl_GetDeviceIdRequest { 
    char dummy_field;
} particle_ctrl_GetDeviceIdRequest;

/* Get the current device mode */
typedef struct _particle_ctrl_GetDeviceModeRequest { 
    char dummy_field;
} particle_ctrl_GetDeviceModeRequest;

/* Get the NCP (network coprocessor) firmware version */
typedef struct _particle_ctrl_GetNcpFirmwareVersionRequest { 
    char dummy_field;
} particle_ctrl_GetNcpFirmwareVersionRequest;

typedef struct _particle_ctrl_GetProtectedStateRequest { 
    char dummy_field;
} particle_ctrl_GetProtectedStateRequest;

typedef struct _particle_ctrl_GetSecurityKeyReply { 
    pb_callback_t data; /* Key data in DER format */
} particle_ctrl_GetSecurityKeyReply;

/* Get the device's serial number */
typedef struct _particle_ctrl_GetSerialNumberRequest { 
    char dummy_field;
} particle_ctrl_GetSerialNumberRequest;

typedef struct _particle_ctrl_GetServerProtocolRequest { 
    char dummy_field;
} particle_ctrl_GetServerProtocolRequest;

/* Get system capabilities */
typedef struct _particle_ctrl_GetSystemCapabilitiesRequest { 
    char dummy_field;
} particle_ctrl_GetSystemCapabilitiesRequest;

typedef struct _particle_ctrl_GetSystemVersionReply { 
    /* Device OS version in SemVer format */
    pb_callback_t version; 
} particle_ctrl_GetSystemVersionReply;

/* Get the firmware version */
typedef struct _particle_ctrl_GetSystemVersionRequest { 
    char dummy_field;
} particle_ctrl_GetSystemVersionRequest;

typedef struct _particle_ctrl_IsClaimedRequest { 
    char dummy_field;
} particle_ctrl_IsClaimedRequest;

/* Get the flag indicating if the device has been set up */
typedef struct _particle_ctrl_IsDeviceSetupDoneRequest { 
    char dummy_field;
} particle_ctrl_IsDeviceSetupDoneRequest;

typedef struct _particle_ctrl_SetClaimCodeReply { 
    char dummy_field;
} particle_ctrl_SetClaimCodeReply;

typedef struct _particle_ctrl_SetDeviceSetupDoneReply { 
    char dummy_field;
} particle_ctrl_SetDeviceSetupDoneReply;

typedef struct _particle_ctrl_SetFeatureReply { 
    char dummy_field;
} particle_ctrl_SetFeatureReply;

typedef struct _particle_ctrl_SetSecurityKeyReply { 
    char dummy_field;
} particle_ctrl_SetSecurityKeyReply;

typedef struct _particle_ctrl_SetServerAddressReply { 
    char dummy_field;
} particle_ctrl_SetServerAddressReply;

typedef struct _particle_ctrl_SetServerProtocolReply { 
    char dummy_field;
} particle_ctrl_SetServerProtocolReply;

typedef struct _particle_ctrl_SetSoftApSsidReply { 
    char dummy_field;
} particle_ctrl_SetSoftApSsidReply;

typedef struct _particle_ctrl_SetStartupModeReply { 
    char dummy_field;
} particle_ctrl_SetStartupModeReply;

typedef struct _particle_ctrl_StartListeningModeReply { 
    char dummy_field;
} particle_ctrl_StartListeningModeReply;

/* Put the device into listening mode */
typedef struct _particle_ctrl_StartListeningModeRequest { 
    char dummy_field;
} particle_ctrl_StartListeningModeRequest;

typedef struct _particle_ctrl_StartNyanSignalReply { 
    char dummy_field;
} particle_ctrl_StartNyanSignalReply;

/* Make the device's status LED display a rainbow pattern aka Nyan mode */
typedef struct _particle_ctrl_StartNyanSignalRequest { 
    char dummy_field;
} particle_ctrl_StartNyanSignalRequest;

typedef struct _particle_ctrl_StopListeningModeReply { 
    char dummy_field;
} particle_ctrl_StopListeningModeReply;

/* Put the device into normal mode */
typedef struct _particle_ctrl_StopListeningModeRequest { 
    char dummy_field;
} particle_ctrl_StopListeningModeRequest;

typedef struct _particle_ctrl_StopNyanSignalReply { 
    char dummy_field;
} particle_ctrl_StopNyanSignalReply;

/* Exit the Nyan mode */
typedef struct _particle_ctrl_StopNyanSignalRequest { 
    char dummy_field;
} particle_ctrl_StopNyanSignalRequest;

typedef struct _particle_ctrl_SystemResetReply { 
    char dummy_field;
} particle_ctrl_SystemResetReply;

/* Resets the device, just like hitting the reset button or powering down and back up */
typedef struct _particle_ctrl_SystemResetRequest { 
    char dummy_field;
} particle_ctrl_SystemResetRequest;

typedef struct _particle_ctrl_GetDeviceIdReply { 
    /* Device ID (hex-encoded) */
    char id[25]; 
} particle_ctrl_GetDeviceIdReply;

typedef struct _particle_ctrl_GetDeviceModeReply { 
    particle_ctrl_DeviceMode mode; 
} particle_ctrl_GetDeviceModeReply;

typedef struct _particle_ctrl_GetFeatureReply { 
    bool enabled; 
} particle_ctrl_GetFeatureReply;

/* Check if the system feature is enabled or disabled */
typedef struct _particle_ctrl_GetFeatureRequest { 
    particle_ctrl_Feature feature; 
} particle_ctrl_GetFeatureRequest;

typedef struct _particle_ctrl_GetNcpFirmwareVersionReply { 
    /* NCP version in SemVer format */
    pb_callback_t version; 
    /* NCP module version */
    uint32_t module_version; 
} particle_ctrl_GetNcpFirmwareVersionReply;

typedef struct _particle_ctrl_GetProtectedStateReply { 
    bool state; 
} particle_ctrl_GetProtectedStateReply;

typedef struct _particle_ctrl_GetSecurityKeyRequest { 
    particle_ctrl_SecurityKeyType type; /* Key type */
} particle_ctrl_GetSecurityKeyRequest;

typedef struct _particle_ctrl_GetSerialNumberReply { 
    /* Device serial ID */
    char serial[17]; 
} particle_ctrl_GetSerialNumberReply;

typedef struct _particle_ctrl_GetServerAddressReply { 
    pb_callback_t address; /* Server address */
    int32_t port; /* Port number */
} particle_ctrl_GetServerAddressReply;

typedef struct _particle_ctrl_GetServerAddressRequest { 
    particle_ctrl_ServerProtocolType protocol; /* Protocol type */
} particle_ctrl_GetServerAddressRequest;

typedef struct _particle_ctrl_GetServerProtocolReply { 
    particle_ctrl_ServerProtocolType protocol; /* Protocol type */
} particle_ctrl_GetServerProtocolReply;

typedef struct _particle_ctrl_GetSystemCapabilitiesReply { 
    /* SystemCapabilityFlag flags */
    uint32_t flags; 
} particle_ctrl_GetSystemCapabilitiesReply;

typedef struct _particle_ctrl_IsClaimedReply { 
    /* `true` if device is claimed */
    bool claimed; 
} particle_ctrl_IsClaimedReply;

typedef struct _particle_ctrl_IsDeviceSetupDoneReply { 
    bool done; 
} particle_ctrl_IsDeviceSetupDoneReply;

typedef struct _particle_ctrl_SetClaimCodeRequest { 
    char code[65]; /* Claim code */
} particle_ctrl_SetClaimCodeRequest;

/* Set flag for setup being done */
typedef struct _particle_ctrl_SetDeviceSetupDoneRequest { 
    bool done; 
} particle_ctrl_SetDeviceSetupDoneRequest;

/* Enable/disable system features */
typedef struct _particle_ctrl_SetFeatureRequest { 
    particle_ctrl_Feature feature; 
    bool enabled; 
} particle_ctrl_SetFeatureRequest;

typedef struct _particle_ctrl_SetSecurityKeyRequest { 
    particle_ctrl_SecurityKeyType type; /* Key type */
    pb_callback_t data; /* Key data in DER format */
} particle_ctrl_SetSecurityKeyRequest;

typedef struct _particle_ctrl_SetServerAddressRequest { 
    particle_ctrl_ServerProtocolType protocol; /* Protocol type */
    char address[65]; /* Server address */
    int32_t port; /* Port number */
} particle_ctrl_SetServerAddressRequest;

typedef struct _particle_ctrl_SetServerProtocolRequest { 
    particle_ctrl_ServerProtocolType protocol; /* Protocol type */
} particle_ctrl_SetServerProtocolRequest;

/* Set the SoftAP SSID prefix and suffix */
typedef struct _particle_ctrl_SetSoftApSsidRequest { 
    char prefix[33]; /* SSID prefix */
    char suffix[17]; /* SSID sufix */
} particle_ctrl_SetSoftApSsidRequest;

/* Set the mode to enter when in safe mode */
typedef struct _particle_ctrl_SetStartupModeRequest { 
    particle_ctrl_DeviceMode mode; 
} particle_ctrl_SetStartupModeRequest;


/* Helper constants for enums */
#define _particle_ctrl_SecurityKeyType_MIN particle_ctrl_SecurityKeyType_INVALID_SECURITY_KEY
#define _particle_ctrl_SecurityKeyType_MAX particle_ctrl_SecurityKeyType_UDP_SERVER_PUBLIC_KEY
#define _particle_ctrl_SecurityKeyType_ARRAYSIZE ((particle_ctrl_SecurityKeyType)(particle_ctrl_SecurityKeyType_UDP_SERVER_PUBLIC_KEY+1))

#define _particle_ctrl_ServerProtocolType_MIN particle_ctrl_ServerProtocolType_INVALID_PROTOCOL
#define _particle_ctrl_ServerProtocolType_MAX particle_ctrl_ServerProtocolType_UDP_PROTOCOL
#define _particle_ctrl_ServerProtocolType_ARRAYSIZE ((particle_ctrl_ServerProtocolType)(particle_ctrl_ServerProtocolType_UDP_PROTOCOL+1))

#define _particle_ctrl_DeviceMode_MIN particle_ctrl_DeviceMode_NORMAL_MODE
#define _particle_ctrl_DeviceMode_MAX particle_ctrl_DeviceMode_LISTENING_MODE
#define _particle_ctrl_DeviceMode_ARRAYSIZE ((particle_ctrl_DeviceMode)(particle_ctrl_DeviceMode_LISTENING_MODE+1))

#define _particle_ctrl_SystemCapabilityFlag_MIN particle_ctrl_SystemCapabilityFlag_NO_SYSTEM_CAPABILITY_FLAGS
#define _particle_ctrl_SystemCapabilityFlag_MAX particle_ctrl_SystemCapabilityFlag_COMPRESSED_OTA
#define _particle_ctrl_SystemCapabilityFlag_ARRAYSIZE ((particle_ctrl_SystemCapabilityFlag)(particle_ctrl_SystemCapabilityFlag_COMPRESSED_OTA+1))

#define _particle_ctrl_Feature_MIN particle_ctrl_Feature_INVALID_FEATURE
#define _particle_ctrl_Feature_MAX particle_ctrl_Feature_ETHERNET_DETECTION
#define _particle_ctrl_Feature_ARRAYSIZE ((particle_ctrl_Feature)(particle_ctrl_Feature_ETHERNET_DETECTION+1))


#ifdef __cplusplus
extern "C" {
#endif

/* Initializer values for message structs */
#define particle_ctrl_GetDeviceIdRequest_init_default {0}
#define particle_ctrl_GetDeviceIdReply_init_default {""}
#define particle_ctrl_GetSerialNumberRequest_init_default {0}
#define particle_ctrl_GetSerialNumberReply_init_default {""}
#define particle_ctrl_GetSystemVersionRequest_init_default {0}
#define particle_ctrl_GetSystemVersionReply_init_default {{{NULL}, NULL}}
#define particle_ctrl_GetNcpFirmwareVersionRequest_init_default {0}
#define particle_ctrl_GetNcpFirmwareVersionReply_init_default {{{NULL}, NULL}, 0}
#define particle_ctrl_GetSystemCapabilitiesRequest_init_default {0}
#define particle_ctrl_GetSystemCapabilitiesReply_init_default {0}
#define particle_ctrl_SetClaimCodeRequest_init_default {""}
#define particle_ctrl_SetClaimCodeReply_init_default {0}
#define particle_ctrl_IsClaimedRequest_init_default {0}
#define particle_ctrl_IsClaimedReply_init_default {0}
#define particle_ctrl_SetSecurityKeyRequest_init_default {_particle_ctrl_SecurityKeyType_MIN, {{NULL}, NULL}}
#define particle_ctrl_SetSecurityKeyReply_init_default {0}
#define particle_ctrl_GetSecurityKeyRequest_init_default {_particle_ctrl_SecurityKeyType_MIN}
#define particle_ctrl_GetSecurityKeyReply_init_default {{{NULL}, NULL}}
#define particle_ctrl_SetServerAddressRequest_init_default {_particle_ctrl_ServerProtocolType_MIN, "", 0}
#define particle_ctrl_SetServerAddressReply_init_default {0}
#define particle_ctrl_GetServerAddressRequest_init_default {_particle_ctrl_ServerProtocolType_MIN}
#define particle_ctrl_GetServerAddressReply_init_default {{{NULL}, NULL}, 0}
#define particle_ctrl_SetServerProtocolRequest_init_default {_particle_ctrl_ServerProtocolType_MIN}
#define particle_ctrl_SetServerProtocolReply_init_default {0}
#define particle_ctrl_GetServerProtocolRequest_init_default {0}
#define particle_ctrl_GetServerProtocolReply_init_default {_particle_ctrl_ServerProtocolType_MIN}
#define particle_ctrl_SetSoftApSsidRequest_init_default {"", ""}
#define particle_ctrl_SetSoftApSsidReply_init_default {0}
#define particle_ctrl_StartListeningModeRequest_init_default {0}
#define particle_ctrl_StartListeningModeReply_init_default {0}
#define particle_ctrl_StopListeningModeRequest_init_default {0}
#define particle_ctrl_StopListeningModeReply_init_default {0}
#define particle_ctrl_GetDeviceModeRequest_init_default {0}
#define particle_ctrl_GetDeviceModeReply_init_default {_particle_ctrl_DeviceMode_MIN}
#define particle_ctrl_SetDeviceSetupDoneRequest_init_default {0}
#define particle_ctrl_SetDeviceSetupDoneReply_init_default {0}
#define particle_ctrl_IsDeviceSetupDoneRequest_init_default {0}
#define particle_ctrl_IsDeviceSetupDoneReply_init_default {0}
#define particle_ctrl_SetStartupModeRequest_init_default {_particle_ctrl_DeviceMode_MIN}
#define particle_ctrl_SetStartupModeReply_init_default {0}
#define particle_ctrl_GetProtectedStateRequest_init_default {0}
#define particle_ctrl_GetProtectedStateReply_init_default {0}
#define particle_ctrl_SystemResetRequest_init_default {0}
#define particle_ctrl_SystemResetReply_init_default {0}
#define particle_ctrl_SetFeatureRequest_init_default {_particle_ctrl_Feature_MIN, 0}
#define particle_ctrl_SetFeatureReply_init_default {0}
#define particle_ctrl_GetFeatureRequest_init_default {_particle_ctrl_Feature_MIN}
#define particle_ctrl_GetFeatureReply_init_default {0}
#define particle_ctrl_StartNyanSignalRequest_init_default {0}
#define particle_ctrl_StartNyanSignalReply_init_default {0}
#define particle_ctrl_StopNyanSignalRequest_init_default {0}
#define particle_ctrl_StopNyanSignalReply_init_default {0}
#define particle_ctrl_GetDeviceIdRequest_init_zero {0}
#define particle_ctrl_GetDeviceIdReply_init_zero {""}
#define particle_ctrl_GetSerialNumberRequest_init_zero {0}
#define particle_ctrl_GetSerialNumberReply_init_zero {""}
#define particle_ctrl_GetSystemVersionRequest_init_zero {0}
#define particle_ctrl_GetSystemVersionReply_init_zero {{{NULL}, NULL}}
#define particle_ctrl_GetNcpFirmwareVersionRequest_init_zero {0}
#define particle_ctrl_GetNcpFirmwareVersionReply_init_zero {{{NULL}, NULL}, 0}
#define particle_ctrl_GetSystemCapabilitiesRequest_init_zero {0}
#define particle_ctrl_GetSystemCapabilitiesReply_init_zero {0}
#define particle_ctrl_SetClaimCodeRequest_init_zero {""}
#define particle_ctrl_SetClaimCodeReply_init_zero {0}
#define particle_ctrl_IsClaimedRequest_init_zero {0}
#define particle_ctrl_IsClaimedReply_init_zero   {0}
#define particle_ctrl_SetSecurityKeyRequest_init_zero {_particle_ctrl_SecurityKeyType_MIN, {{NULL}, NULL}}
#define particle_ctrl_SetSecurityKeyReply_init_zero {0}
#define particle_ctrl_GetSecurityKeyRequest_init_zero {_particle_ctrl_SecurityKeyType_MIN}
#define particle_ctrl_GetSecurityKeyReply_init_zero {{{NULL}, NULL}}
#define particle_ctrl_SetServerAddressRequest_init_zero {_particle_ctrl_ServerProtocolType_MIN, "", 0}
#define particle_ctrl_SetServerAddressReply_init_zero {0}
#define particle_ctrl_GetServerAddressRequest_init_zero {_particle_ctrl_ServerProtocolType_MIN}
#define particle_ctrl_GetServerAddressReply_init_zero {{{NULL}, NULL}, 0}
#define particle_ctrl_SetServerProtocolRequest_init_zero {_particle_ctrl_ServerProtocolType_MIN}
#define particle_ctrl_SetServerProtocolReply_init_zero {0}
#define particle_ctrl_GetServerProtocolRequest_init_zero {0}
#define particle_ctrl_GetServerProtocolReply_init_zero {_particle_ctrl_ServerProtocolType_MIN}
#define particle_ctrl_SetSoftApSsidRequest_init_zero {"", ""}
#define particle_ctrl_SetSoftApSsidReply_init_zero {0}
#define particle_ctrl_StartListeningModeRequest_init_zero {0}
#define particle_ctrl_StartListeningModeReply_init_zero {0}
#define particle_ctrl_StopListeningModeRequest_init_zero {0}
#define particle_ctrl_StopListeningModeReply_init_zero {0}
#define particle_ctrl_GetDeviceModeRequest_init_zero {0}
#define particle_ctrl_GetDeviceModeReply_init_zero {_particle_ctrl_DeviceMode_MIN}
#define particle_ctrl_SetDeviceSetupDoneRequest_init_zero {0}
#define particle_ctrl_SetDeviceSetupDoneReply_init_zero {0}
#define particle_ctrl_IsDeviceSetupDoneRequest_init_zero {0}
#define particle_ctrl_IsDeviceSetupDoneReply_init_zero {0}
#define particle_ctrl_SetStartupModeRequest_init_zero {_particle_ctrl_DeviceMode_MIN}
#define particle_ctrl_SetStartupModeReply_init_zero {0}
#define particle_ctrl_GetProtectedStateRequest_init_zero {0}
#define particle_ctrl_GetProtectedStateReply_init_zero {0}
#define particle_ctrl_SystemResetRequest_init_zero {0}
#define particle_ctrl_SystemResetReply_init_zero {0}
#define particle_ctrl_SetFeatureRequest_init_zero {_particle_ctrl_Feature_MIN, 0}
#define particle_ctrl_SetFeatureReply_init_zero  {0}
#define particle_ctrl_GetFeatureRequest_init_zero {_particle_ctrl_Feature_MIN}
#define particle_ctrl_GetFeatureReply_init_zero  {0}
#define particle_ctrl_StartNyanSignalRequest_init_zero {0}
#define particle_ctrl_StartNyanSignalReply_init_zero {0}
#define particle_ctrl_StopNyanSignalRequest_init_zero {0}
#define particle_ctrl_StopNyanSignalReply_init_zero {0}

/* Field tags (for use in manual encoding/decoding) */
#define particle_ctrl_GetSecurityKeyReply_data_tag 1
#define particle_ctrl_GetSystemVersionReply_version_tag 1
#define particle_ctrl_GetDeviceIdReply_id_tag    1
#define particle_ctrl_GetDeviceModeReply_mode_tag 1
#define particle_ctrl_GetFeatureReply_enabled_tag 1
#define particle_ctrl_GetFeatureRequest_feature_tag 1
#define particle_ctrl_GetNcpFirmwareVersionReply_version_tag 1
#define particle_ctrl_GetNcpFirmwareVersionReply_module_version_tag 2
#define particle_ctrl_GetProtectedStateReply_state_tag 1
#define particle_ctrl_GetSecurityKeyRequest_type_tag 1
#define particle_ctrl_GetSerialNumberReply_serial_tag 1
#define particle_ctrl_GetServerAddressReply_address_tag 1
#define particle_ctrl_GetServerAddressReply_port_tag 2
#define particle_ctrl_GetServerAddressRequest_protocol_tag 1
#define particle_ctrl_GetServerProtocolReply_protocol_tag 1
#define particle_ctrl_GetSystemCapabilitiesReply_flags_tag 1
#define particle_ctrl_IsClaimedReply_claimed_tag 1
#define particle_ctrl_IsDeviceSetupDoneReply_done_tag 1
#define particle_ctrl_SetClaimCodeRequest_code_tag 1
#define particle_ctrl_SetDeviceSetupDoneRequest_done_tag 1
#define particle_ctrl_SetFeatureRequest_feature_tag 1
#define particle_ctrl_SetFeatureRequest_enabled_tag 2
#define particle_ctrl_SetSecurityKeyRequest_type_tag 1
#define particle_ctrl_SetSecurityKeyRequest_data_tag 2
#define particle_ctrl_SetServerAddressRequest_protocol_tag 1
#define particle_ctrl_SetServerAddressRequest_address_tag 2
#define particle_ctrl_SetServerAddressRequest_port_tag 3
#define particle_ctrl_SetServerProtocolRequest_protocol_tag 1
#define particle_ctrl_SetSoftApSsidRequest_prefix_tag 1
#define particle_ctrl_SetSoftApSsidRequest_suffix_tag 2
#define particle_ctrl_SetStartupModeRequest_mode_tag 1

/* Struct field encoding specification for nanopb */
#define particle_ctrl_GetDeviceIdRequest_FIELDLIST(X, a) \

#define particle_ctrl_GetDeviceIdRequest_CALLBACK NULL
#define particle_ctrl_GetDeviceIdRequest_DEFAULT NULL

#define particle_ctrl_GetDeviceIdReply_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, STRING,   id,                1)
#define particle_ctrl_GetDeviceIdReply_CALLBACK NULL
#define particle_ctrl_GetDeviceIdReply_DEFAULT NULL

#define particle_ctrl_GetSerialNumberRequest_FIELDLIST(X, a) \

#define particle_ctrl_GetSerialNumberRequest_CALLBACK NULL
#define particle_ctrl_GetSerialNumberRequest_DEFAULT NULL

#define particle_ctrl_GetSerialNumberReply_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, STRING,   serial,            1)
#define particle_ctrl_GetSerialNumberReply_CALLBACK NULL
#define particle_ctrl_GetSerialNumberReply_DEFAULT NULL

#define particle_ctrl_GetSystemVersionRequest_FIELDLIST(X, a) \

#define particle_ctrl_GetSystemVersionRequest_CALLBACK NULL
#define particle_ctrl_GetSystemVersionRequest_DEFAULT NULL

#define particle_ctrl_GetSystemVersionReply_FIELDLIST(X, a) \
X(a, CALLBACK, SINGULAR, STRING,   version,           1)
#define particle_ctrl_GetSystemVersionReply_CALLBACK pb_default_field_callback
#define particle_ctrl_GetSystemVersionReply_DEFAULT NULL

#define particle_ctrl_GetNcpFirmwareVersionRequest_FIELDLIST(X, a) \

#define particle_ctrl_GetNcpFirmwareVersionRequest_CALLBACK NULL
#define particle_ctrl_GetNcpFirmwareVersionRequest_DEFAULT NULL

#define particle_ctrl_GetNcpFirmwareVersionReply_FIELDLIST(X, a) \
X(a, CALLBACK, SINGULAR, STRING,   version,           1) \
X(a, STATIC,   SINGULAR, UINT32,   module_version,    2)
#define particle_ctrl_GetNcpFirmwareVersionReply_CALLBACK pb_default_field_callback
#define particle_ctrl_GetNcpFirmwareVersionReply_DEFAULT NULL

#define particle_ctrl_GetSystemCapabilitiesRequest_FIELDLIST(X, a) \

#define particle_ctrl_GetSystemCapabilitiesRequest_CALLBACK NULL
#define particle_ctrl_GetSystemCapabilitiesRequest_DEFAULT NULL

#define particle_ctrl_GetSystemCapabilitiesReply_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, FIXED32,  flags,             1)
#define particle_ctrl_GetSystemCapabilitiesReply_CALLBACK NULL
#define particle_ctrl_GetSystemCapabilitiesReply_DEFAULT NULL

#define particle_ctrl_SetClaimCodeRequest_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, STRING,   code,              1)
#define particle_ctrl_SetClaimCodeRequest_CALLBACK NULL
#define particle_ctrl_SetClaimCodeRequest_DEFAULT NULL

#define particle_ctrl_SetClaimCodeReply_FIELDLIST(X, a) \

#define particle_ctrl_SetClaimCodeReply_CALLBACK NULL
#define particle_ctrl_SetClaimCodeReply_DEFAULT NULL

#define particle_ctrl_IsClaimedRequest_FIELDLIST(X, a) \

#define particle_ctrl_IsClaimedRequest_CALLBACK NULL
#define particle_ctrl_IsClaimedRequest_DEFAULT NULL

#define particle_ctrl_IsClaimedReply_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, BOOL,     claimed,           1)
#define particle_ctrl_IsClaimedReply_CALLBACK NULL
#define particle_ctrl_IsClaimedReply_DEFAULT NULL

#define particle_ctrl_SetSecurityKeyRequest_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UENUM,    type,              1) \
X(a, CALLBACK, SINGULAR, BYTES,    data,              2)
#define particle_ctrl_SetSecurityKeyRequest_CALLBACK pb_default_field_callback
#define particle_ctrl_SetSecurityKeyRequest_DEFAULT NULL

#define particle_ctrl_SetSecurityKeyReply_FIELDLIST(X, a) \

#define particle_ctrl_SetSecurityKeyReply_CALLBACK NULL
#define particle_ctrl_SetSecurityKeyReply_DEFAULT NULL

#define particle_ctrl_GetSecurityKeyRequest_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UENUM,    type,              1)
#define particle_ctrl_GetSecurityKeyRequest_CALLBACK NULL
#define particle_ctrl_GetSecurityKeyRequest_DEFAULT NULL

#define particle_ctrl_GetSecurityKeyReply_FIELDLIST(X, a) \
X(a, CALLBACK, SINGULAR, BYTES,    data,              1)
#define particle_ctrl_GetSecurityKeyReply_CALLBACK pb_default_field_callback
#define particle_ctrl_GetSecurityKeyReply_DEFAULT NULL

#define particle_ctrl_SetServerAddressRequest_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UENUM,    protocol,          1) \
X(a, STATIC,   SINGULAR, STRING,   address,           2) \
X(a, STATIC,   SINGULAR, INT32,    port,              3)
#define particle_ctrl_SetServerAddressRequest_CALLBACK NULL
#define particle_ctrl_SetServerAddressRequest_DEFAULT NULL

#define particle_ctrl_SetServerAddressReply_FIELDLIST(X, a) \

#define particle_ctrl_SetServerAddressReply_CALLBACK NULL
#define particle_ctrl_SetServerAddressReply_DEFAULT NULL

#define particle_ctrl_GetServerAddressRequest_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UENUM,    protocol,          1)
#define particle_ctrl_GetServerAddressRequest_CALLBACK NULL
#define particle_ctrl_GetServerAddressRequest_DEFAULT NULL

#define particle_ctrl_GetServerAddressReply_FIELDLIST(X, a) \
X(a, CALLBACK, SINGULAR, STRING,   address,           1) \
X(a, STATIC,   SINGULAR, INT32,    port,              2)
#define particle_ctrl_GetServerAddressReply_CALLBACK pb_default_field_callback
#define particle_ctrl_GetServerAddressReply_DEFAULT NULL

#define particle_ctrl_SetServerProtocolRequest_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UENUM,    protocol,          1)
#define particle_ctrl_SetServerProtocolRequest_CALLBACK NULL
#define particle_ctrl_SetServerProtocolRequest_DEFAULT NULL

#define particle_ctrl_SetServerProtocolReply_FIELDLIST(X, a) \

#define particle_ctrl_SetServerProtocolReply_CALLBACK NULL
#define particle_ctrl_SetServerProtocolReply_DEFAULT NULL

#define particle_ctrl_GetServerProtocolRequest_FIELDLIST(X, a) \

#define particle_ctrl_GetServerProtocolRequest_CALLBACK NULL
#define particle_ctrl_GetServerProtocolRequest_DEFAULT NULL

#define particle_ctrl_GetServerProtocolReply_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UENUM,    protocol,          1)
#define particle_ctrl_GetServerProtocolReply_CALLBACK NULL
#define particle_ctrl_GetServerProtocolReply_DEFAULT NULL

#define particle_ctrl_SetSoftApSsidRequest_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, STRING,   prefix,            1) \
X(a, STATIC,   SINGULAR, STRING,   suffix,            2)
#define particle_ctrl_SetSoftApSsidRequest_CALLBACK NULL
#define particle_ctrl_SetSoftApSsidRequest_DEFAULT NULL

#define particle_ctrl_SetSoftApSsidReply_FIELDLIST(X, a) \

#define particle_ctrl_SetSoftApSsidReply_CALLBACK NULL
#define particle_ctrl_SetSoftApSsidReply_DEFAULT NULL

#define particle_ctrl_StartListeningModeRequest_FIELDLIST(X, a) \

#define particle_ctrl_StartListeningModeRequest_CALLBACK NULL
#define particle_ctrl_StartListeningModeRequest_DEFAULT NULL

#define particle_ctrl_StartListeningModeReply_FIELDLIST(X, a) \

#define particle_ctrl_StartListeningModeReply_CALLBACK NULL
#define particle_ctrl_StartListeningModeReply_DEFAULT NULL

#define particle_ctrl_StopListeningModeRequest_FIELDLIST(X, a) \

#define particle_ctrl_StopListeningModeRequest_CALLBACK NULL
#define particle_ctrl_StopListeningModeRequest_DEFAULT NULL

#define particle_ctrl_StopListeningModeReply_FIELDLIST(X, a) \

#define particle_ctrl_StopListeningModeReply_CALLBACK NULL
#define particle_ctrl_StopListeningModeReply_DEFAULT NULL

#define particle_ctrl_GetDeviceModeRequest_FIELDLIST(X, a) \

#define particle_ctrl_GetDeviceModeRequest_CALLBACK NULL
#define particle_ctrl_GetDeviceModeRequest_DEFAULT NULL

#define particle_ctrl_GetDeviceModeReply_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UENUM,    mode,              1)
#define particle_ctrl_GetDeviceModeReply_CALLBACK NULL
#define particle_ctrl_GetDeviceModeReply_DEFAULT NULL

#define particle_ctrl_SetDeviceSetupDoneRequest_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, BOOL,     done,              1)
#define particle_ctrl_SetDeviceSetupDoneRequest_CALLBACK NULL
#define particle_ctrl_SetDeviceSetupDoneRequest_DEFAULT NULL

#define particle_ctrl_SetDeviceSetupDoneReply_FIELDLIST(X, a) \

#define particle_ctrl_SetDeviceSetupDoneReply_CALLBACK NULL
#define particle_ctrl_SetDeviceSetupDoneReply_DEFAULT NULL

#define particle_ctrl_IsDeviceSetupDoneRequest_FIELDLIST(X, a) \

#define particle_ctrl_IsDeviceSetupDoneRequest_CALLBACK NULL
#define particle_ctrl_IsDeviceSetupDoneRequest_DEFAULT NULL

#define particle_ctrl_IsDeviceSetupDoneReply_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, BOOL,     done,              1)
#define particle_ctrl_IsDeviceSetupDoneReply_CALLBACK NULL
#define particle_ctrl_IsDeviceSetupDoneReply_DEFAULT NULL

#define particle_ctrl_SetStartupModeRequest_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UENUM,    mode,              1)
#define particle_ctrl_SetStartupModeRequest_CALLBACK NULL
#define particle_ctrl_SetStartupModeRequest_DEFAULT NULL

#define particle_ctrl_SetStartupModeReply_FIELDLIST(X, a) \

#define particle_ctrl_SetStartupModeReply_CALLBACK NULL
#define particle_ctrl_SetStartupModeReply_DEFAULT NULL

#define particle_ctrl_GetProtectedStateRequest_FIELDLIST(X, a) \

#define particle_ctrl_GetProtectedStateRequest_CALLBACK NULL
#define particle_ctrl_GetProtectedStateRequest_DEFAULT NULL

#define particle_ctrl_GetProtectedStateReply_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, BOOL,     state,             1)
#define particle_ctrl_GetProtectedStateReply_CALLBACK NULL
#define particle_ctrl_GetProtectedStateReply_DEFAULT NULL

#define particle_ctrl_SystemResetRequest_FIELDLIST(X, a) \

#define particle_ctrl_SystemResetRequest_CALLBACK NULL
#define particle_ctrl_SystemResetRequest_DEFAULT NULL

#define particle_ctrl_SystemResetReply_FIELDLIST(X, a) \

#define particle_ctrl_SystemResetReply_CALLBACK NULL
#define particle_ctrl_SystemResetReply_DEFAULT NULL

#define particle_ctrl_SetFeatureRequest_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UENUM,    feature,           1) \
X(a, STATIC,   SINGULAR, BOOL,     enabled,           2)
#define particle_ctrl_SetFeatureRequest_CALLBACK NULL
#define particle_ctrl_SetFeatureRequest_DEFAULT NULL

#define particle_ctrl_SetFeatureReply_FIELDLIST(X, a) \

#define particle_ctrl_SetFeatureReply_CALLBACK NULL
#define particle_ctrl_SetFeatureReply_DEFAULT NULL

#define particle_ctrl_GetFeatureRequest_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UENUM,    feature,           1)
#define particle_ctrl_GetFeatureRequest_CALLBACK NULL
#define particle_ctrl_GetFeatureRequest_DEFAULT NULL

#define particle_ctrl_GetFeatureReply_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, BOOL,     enabled,           1)
#define particle_ctrl_GetFeatureReply_CALLBACK NULL
#define particle_ctrl_GetFeatureReply_DEFAULT NULL

#define particle_ctrl_StartNyanSignalRequest_FIELDLIST(X, a) \

#define particle_ctrl_StartNyanSignalRequest_CALLBACK NULL
#define particle_ctrl_StartNyanSignalRequest_DEFAULT NULL

#define particle_ctrl_StartNyanSignalReply_FIELDLIST(X, a) \

#define particle_ctrl_StartNyanSignalReply_CALLBACK NULL
#define particle_ctrl_StartNyanSignalReply_DEFAULT NULL

#define particle_ctrl_StopNyanSignalRequest_FIELDLIST(X, a) \

#define particle_ctrl_StopNyanSignalRequest_CALLBACK NULL
#define particle_ctrl_StopNyanSignalRequest_DEFAULT NULL

#define particle_ctrl_StopNyanSignalReply_FIELDLIST(X, a) \

#define particle_ctrl_StopNyanSignalReply_CALLBACK NULL
#define particle_ctrl_StopNyanSignalReply_DEFAULT NULL

extern const pb_msgdesc_t particle_ctrl_GetDeviceIdRequest_msg;
extern const pb_msgdesc_t particle_ctrl_GetDeviceIdReply_msg;
extern const pb_msgdesc_t particle_ctrl_GetSerialNumberRequest_msg;
extern const pb_msgdesc_t particle_ctrl_GetSerialNumberReply_msg;
extern const pb_msgdesc_t particle_ctrl_GetSystemVersionRequest_msg;
extern const pb_msgdesc_t particle_ctrl_GetSystemVersionReply_msg;
extern const pb_msgdesc_t particle_ctrl_GetNcpFirmwareVersionRequest_msg;
extern const pb_msgdesc_t particle_ctrl_GetNcpFirmwareVersionReply_msg;
extern const pb_msgdesc_t particle_ctrl_GetSystemCapabilitiesRequest_msg;
extern const pb_msgdesc_t particle_ctrl_GetSystemCapabilitiesReply_msg;
extern const pb_msgdesc_t particle_ctrl_SetClaimCodeRequest_msg;
extern const pb_msgdesc_t particle_ctrl_SetClaimCodeReply_msg;
extern const pb_msgdesc_t particle_ctrl_IsClaimedRequest_msg;
extern const pb_msgdesc_t particle_ctrl_IsClaimedReply_msg;
extern const pb_msgdesc_t particle_ctrl_SetSecurityKeyRequest_msg;
extern const pb_msgdesc_t particle_ctrl_SetSecurityKeyReply_msg;
extern const pb_msgdesc_t particle_ctrl_GetSecurityKeyRequest_msg;
extern const pb_msgdesc_t particle_ctrl_GetSecurityKeyReply_msg;
extern const pb_msgdesc_t particle_ctrl_SetServerAddressRequest_msg;
extern const pb_msgdesc_t particle_ctrl_SetServerAddressReply_msg;
extern const pb_msgdesc_t particle_ctrl_GetServerAddressRequest_msg;
extern const pb_msgdesc_t particle_ctrl_GetServerAddressReply_msg;
extern const pb_msgdesc_t particle_ctrl_SetServerProtocolRequest_msg;
extern const pb_msgdesc_t particle_ctrl_SetServerProtocolReply_msg;
extern const pb_msgdesc_t particle_ctrl_GetServerProtocolRequest_msg;
extern const pb_msgdesc_t particle_ctrl_GetServerProtocolReply_msg;
extern const pb_msgdesc_t particle_ctrl_SetSoftApSsidRequest_msg;
extern const pb_msgdesc_t particle_ctrl_SetSoftApSsidReply_msg;
extern const pb_msgdesc_t particle_ctrl_StartListeningModeRequest_msg;
extern const pb_msgdesc_t particle_ctrl_StartListeningModeReply_msg;
extern const pb_msgdesc_t particle_ctrl_StopListeningModeRequest_msg;
extern const pb_msgdesc_t particle_ctrl_StopListeningModeReply_msg;
extern const pb_msgdesc_t particle_ctrl_GetDeviceModeRequest_msg;
extern const pb_msgdesc_t particle_ctrl_GetDeviceModeReply_msg;
extern const pb_msgdesc_t particle_ctrl_SetDeviceSetupDoneRequest_msg;
extern const pb_msgdesc_t particle_ctrl_SetDeviceSetupDoneReply_msg;
extern const pb_msgdesc_t particle_ctrl_IsDeviceSetupDoneRequest_msg;
extern const pb_msgdesc_t particle_ctrl_IsDeviceSetupDoneReply_msg;
extern const pb_msgdesc_t particle_ctrl_SetStartupModeRequest_msg;
extern const pb_msgdesc_t particle_ctrl_SetStartupModeReply_msg;
extern const pb_msgdesc_t particle_ctrl_GetProtectedStateRequest_msg;
extern const pb_msgdesc_t particle_ctrl_GetProtectedStateReply_msg;
extern const pb_msgdesc_t particle_ctrl_SystemResetRequest_msg;
extern const pb_msgdesc_t particle_ctrl_SystemResetReply_msg;
extern const pb_msgdesc_t particle_ctrl_SetFeatureRequest_msg;
extern const pb_msgdesc_t particle_ctrl_SetFeatureReply_msg;
extern const pb_msgdesc_t particle_ctrl_GetFeatureRequest_msg;
extern const pb_msgdesc_t particle_ctrl_GetFeatureReply_msg;
extern const pb_msgdesc_t particle_ctrl_StartNyanSignalRequest_msg;
extern const pb_msgdesc_t particle_ctrl_StartNyanSignalReply_msg;
extern const pb_msgdesc_t particle_ctrl_StopNyanSignalRequest_msg;
extern const pb_msgdesc_t particle_ctrl_StopNyanSignalReply_msg;

/* Defines for backwards compatibility with code written before nanopb-0.4.0 */
#define particle_ctrl_GetDeviceIdRequest_fields &particle_ctrl_GetDeviceIdRequest_msg
#define particle_ctrl_GetDeviceIdReply_fields &particle_ctrl_GetDeviceIdReply_msg
#define particle_ctrl_GetSerialNumberRequest_fields &particle_ctrl_GetSerialNumberRequest_msg
#define particle_ctrl_GetSerialNumberReply_fields &particle_ctrl_GetSerialNumberReply_msg
#define particle_ctrl_GetSystemVersionRequest_fields &particle_ctrl_GetSystemVersionRequest_msg
#define particle_ctrl_GetSystemVersionReply_fields &particle_ctrl_GetSystemVersionReply_msg
#define particle_ctrl_GetNcpFirmwareVersionRequest_fields &particle_ctrl_GetNcpFirmwareVersionRequest_msg
#define particle_ctrl_GetNcpFirmwareVersionReply_fields &particle_ctrl_GetNcpFirmwareVersionReply_msg
#define particle_ctrl_GetSystemCapabilitiesRequest_fields &particle_ctrl_GetSystemCapabilitiesRequest_msg
#define particle_ctrl_GetSystemCapabilitiesReply_fields &particle_ctrl_GetSystemCapabilitiesReply_msg
#define particle_ctrl_SetClaimCodeRequest_fields &particle_ctrl_SetClaimCodeRequest_msg
#define particle_ctrl_SetClaimCodeReply_fields &particle_ctrl_SetClaimCodeReply_msg
#define particle_ctrl_IsClaimedRequest_fields &particle_ctrl_IsClaimedRequest_msg
#define particle_ctrl_IsClaimedReply_fields &particle_ctrl_IsClaimedReply_msg
#define particle_ctrl_SetSecurityKeyRequest_fields &particle_ctrl_SetSecurityKeyRequest_msg
#define particle_ctrl_SetSecurityKeyReply_fields &particle_ctrl_SetSecurityKeyReply_msg
#define particle_ctrl_GetSecurityKeyRequest_fields &particle_ctrl_GetSecurityKeyRequest_msg
#define particle_ctrl_GetSecurityKeyReply_fields &particle_ctrl_GetSecurityKeyReply_msg
#define particle_ctrl_SetServerAddressRequest_fields &particle_ctrl_SetServerAddressRequest_msg
#define particle_ctrl_SetServerAddressReply_fields &particle_ctrl_SetServerAddressReply_msg
#define particle_ctrl_GetServerAddressRequest_fields &particle_ctrl_GetServerAddressRequest_msg
#define particle_ctrl_GetServerAddressReply_fields &particle_ctrl_GetServerAddressReply_msg
#define particle_ctrl_SetServerProtocolRequest_fields &particle_ctrl_SetServerProtocolRequest_msg
#define particle_ctrl_SetServerProtocolReply_fields &particle_ctrl_SetServerProtocolReply_msg
#define particle_ctrl_GetServerProtocolRequest_fields &particle_ctrl_GetServerProtocolRequest_msg
#define particle_ctrl_GetServerProtocolReply_fields &particle_ctrl_GetServerProtocolReply_msg
#define particle_ctrl_SetSoftApSsidRequest_fields &particle_ctrl_SetSoftApSsidRequest_msg
#define particle_ctrl_SetSoftApSsidReply_fields &particle_ctrl_SetSoftApSsidReply_msg
#define particle_ctrl_StartListeningModeRequest_fields &particle_ctrl_StartListeningModeRequest_msg
#define particle_ctrl_StartListeningModeReply_fields &particle_ctrl_StartListeningModeReply_msg
#define particle_ctrl_StopListeningModeRequest_fields &particle_ctrl_StopListeningModeRequest_msg
#define particle_ctrl_StopListeningModeReply_fields &particle_ctrl_StopListeningModeReply_msg
#define particle_ctrl_GetDeviceModeRequest_fields &particle_ctrl_GetDeviceModeRequest_msg
#define particle_ctrl_GetDeviceModeReply_fields &particle_ctrl_GetDeviceModeReply_msg
#define particle_ctrl_SetDeviceSetupDoneRequest_fields &particle_ctrl_SetDeviceSetupDoneRequest_msg
#define particle_ctrl_SetDeviceSetupDoneReply_fields &particle_ctrl_SetDeviceSetupDoneReply_msg
#define particle_ctrl_IsDeviceSetupDoneRequest_fields &particle_ctrl_IsDeviceSetupDoneRequest_msg
#define particle_ctrl_IsDeviceSetupDoneReply_fields &particle_ctrl_IsDeviceSetupDoneReply_msg
#define particle_ctrl_SetStartupModeRequest_fields &particle_ctrl_SetStartupModeRequest_msg
#define particle_ctrl_SetStartupModeReply_fields &particle_ctrl_SetStartupModeReply_msg
#define particle_ctrl_GetProtectedStateRequest_fields &particle_ctrl_GetProtectedStateRequest_msg
#define particle_ctrl_GetProtectedStateReply_fields &particle_ctrl_GetProtectedStateReply_msg
#define particle_ctrl_SystemResetRequest_fields &particle_ctrl_SystemResetRequest_msg
#define particle_ctrl_SystemResetReply_fields &particle_ctrl_SystemResetReply_msg
#define particle_ctrl_SetFeatureRequest_fields &particle_ctrl_SetFeatureRequest_msg
#define particle_ctrl_SetFeatureReply_fields &particle_ctrl_SetFeatureReply_msg
#define particle_ctrl_GetFeatureRequest_fields &particle_ctrl_GetFeatureRequest_msg
#define particle_ctrl_GetFeatureReply_fields &particle_ctrl_GetFeatureReply_msg
#define particle_ctrl_StartNyanSignalRequest_fields &particle_ctrl_StartNyanSignalRequest_msg
#define particle_ctrl_StartNyanSignalReply_fields &particle_ctrl_StartNyanSignalReply_msg
#define particle_ctrl_StopNyanSignalRequest_fields &particle_ctrl_StopNyanSignalRequest_msg
#define particle_ctrl_StopNyanSignalReply_fields &particle_ctrl_StopNyanSignalReply_msg

/* Maximum encoded size of messages (where known) */
/* particle_ctrl_GetSystemVersionReply_size depends on runtime parameters */
/* particle_ctrl_GetNcpFirmwareVersionReply_size depends on runtime parameters */
/* particle_ctrl_SetSecurityKeyRequest_size depends on runtime parameters */
/* particle_ctrl_GetSecurityKeyReply_size depends on runtime parameters */
/* particle_ctrl_GetServerAddressReply_size depends on runtime parameters */
#define particle_ctrl_GetDeviceIdReply_size      26
#define particle_ctrl_GetDeviceIdRequest_size    0
#define particle_ctrl_GetDeviceModeReply_size    2
#define particle_ctrl_GetDeviceModeRequest_size  0
#define particle_ctrl_GetFeatureReply_size       2
#define particle_ctrl_GetFeatureRequest_size     2
#define particle_ctrl_GetNcpFirmwareVersionRequest_size 0
#define particle_ctrl_GetProtectedStateReply_size 2
#define particle_ctrl_GetProtectedStateRequest_size 0
#define particle_ctrl_GetSecurityKeyRequest_size 2
#define particle_ctrl_GetSerialNumberReply_size  18
#define particle_ctrl_GetSerialNumberRequest_size 0
#define particle_ctrl_GetServerAddressRequest_size 2
#define particle_ctrl_GetServerProtocolReply_size 2
#define particle_ctrl_GetServerProtocolRequest_size 0
#define particle_ctrl_GetSystemCapabilitiesReply_size 5
#define particle_ctrl_GetSystemCapabilitiesRequest_size 0
#define particle_ctrl_GetSystemVersionRequest_size 0
#define particle_ctrl_IsClaimedReply_size        2
#define particle_ctrl_IsClaimedRequest_size      0
#define particle_ctrl_IsDeviceSetupDoneReply_size 2
#define particle_ctrl_IsDeviceSetupDoneRequest_size 0
#define particle_ctrl_SetClaimCodeReply_size     0
#define particle_ctrl_SetClaimCodeRequest_size   66
#define particle_ctrl_SetDeviceSetupDoneReply_size 0
#define particle_ctrl_SetDeviceSetupDoneRequest_size 2
#define particle_ctrl_SetFeatureReply_size       0
#define particle_ctrl_SetFeatureRequest_size     4
#define particle_ctrl_SetSecurityKeyReply_size   0
#define particle_ctrl_SetServerAddressReply_size 0
#define particle_ctrl_SetServerAddressRequest_size 79
#define particle_ctrl_SetServerProtocolReply_size 0
#define particle_ctrl_SetServerProtocolRequest_size 2
#define particle_ctrl_SetSoftApSsidReply_size    0
#define particle_ctrl_SetSoftApSsidRequest_size  52
#define particle_ctrl_SetStartupModeReply_size   0
#define particle_ctrl_SetStartupModeRequest_size 2
#define particle_ctrl_StartListeningModeReply_size 0
#define particle_ctrl_StartListeningModeRequest_size 0
#define particle_ctrl_StartNyanSignalReply_size  0
#define particle_ctrl_StartNyanSignalRequest_size 0
#define particle_ctrl_StopListeningModeReply_size 0
#define particle_ctrl_StopListeningModeRequest_size 0
#define particle_ctrl_StopNyanSignalReply_size   0
#define particle_ctrl_StopNyanSignalRequest_size 0
#define particle_ctrl_SystemResetReply_size      0
#define particle_ctrl_SystemResetRequest_size    0

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
